/***************************************************************************
                          cajoutfichiers.cpp  -  description
                             -------------------
    begin                : Thu Jun 3 1999
    copyright            : (C) 2000 by Eric Coquelle
    email                : coquelle@caramail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qpixmap.h>
#include <qlayout.h>

#include "cajoutfichiers.h"

#include <kdebug.h>
#define Inherited QDialog


/***************************************************************************
 *  Methods of liste class
 *
 *
 ***************************************************************************/

liste::liste (QWidget* parent, const char* name):QListView( parent, name )
{
}

/*Send a message each time a file is selected
	files are items that do not have a pixmap*/
void liste::contentsMouseReleaseEvent(QMouseEvent* e)
{
	QListViewItem* l;
	
	l=itemAt(contentsToViewport(e->pos()));
	if((l!=0)&&(l->pixmap(0)==NULL))
		emit selectionChangee(l);
}



/***************************************************************************
 *  Methods of CAjoutFichiers class
 *
 *
 ***************************************************************************/
	
CAjoutFichiers::CAjoutFichiers(QDialog* parent,const char* name)
:QDialog( parent, name, TRUE )
{
	KIconLoader icone;
	setIcon(icone.loadIcon("karchiver",KIcon::Small));

   QGridLayout *grid1 = new QGridLayout(this,8,3,15,7);
   listView = new liste( this, "ListView ajoutfichiers" );
   listView->setFrameStyle( 0 );
   listView->setLineWidth( 1 );
   listView->setMidLineWidth( 0 );
   listView->QFrame::setMargin( 0 );
   listView->setTreeStepSize( 20 );
   listView->setAllColumnsShowFocus( FALSE );
   listView->setItemMargin( 1 );
   listView->addColumn( i18n("Choose files:"), -1 );
   listView->setColumnWidthMode( 0, QListView::Maximum );
   listView->setColumnAlignment( 0, 1 );
   listView->setMultiSelection(TRUE);	
   grid1->addMultiCellWidget(listView,0,7,0,0);

   repertoire=new Directory(listView);
   repertoire->setAfficheFichiers(TRUE);
   repertoire->setOpen(TRUE);
   connect(listView, SIGNAL(selectionChangee(QListViewItem*)), this, SLOT(slotSelectionModifiee(QListViewItem*)));
   
   QButtonGroup* qtarch_ButtonGroup;
   qtarch_ButtonGroup = new QButtonGroup( this, "ButtonGroup" );
   qtarch_ButtonGroup->setFocusPolicy( QWidget::NoFocus );
   qtarch_ButtonGroup->setBackgroundMode( QWidget::PaletteBackground );
   qtarch_ButtonGroup->setFrameStyle( 49 );
   qtarch_ButtonGroup->setLineWidth( 1 );
   qtarch_ButtonGroup->setMidLineWidth( 0 );
   qtarch_ButtonGroup->QFrame::setMargin( 0 );
   qtarch_ButtonGroup->setTitle( i18n("Kind of operation:") );
   qtarch_ButtonGroup->setAlignment( 1 );
   qtarch_ButtonGroup->setExclusive( FALSE );
   grid1->addMultiCellWidget( qtarch_ButtonGroup,0,3,1,2);

   connect(qtarch_ButtonGroup,SIGNAL(clicked(int)), this, SLOT(selectionneMotif(int)));

   QGridLayout *grid2 = new QGridLayout(qtarch_ButtonGroup,3,1,15,7); 
   qtarch_RadioAjoute = new QRadioButton( qtarch_ButtonGroup, "RadioAjoute" );
   qtarch_RadioAjoute->setFocusPolicy( QWidget::TabFocus );
   qtarch_RadioAjoute->setBackgroundMode( QWidget::PaletteBackground );
   qtarch_RadioAjoute->setText( i18n("Add files") );
   qtarch_RadioAjoute->setAutoRepeat( FALSE );
   qtarch_RadioAjoute->setAutoResize( FALSE );
   qtarch_RadioAjoute->setChecked( TRUE );
   grid2->addWidget(qtarch_RadioAjoute,0,0);


   qtarch_RadioUpdate = new QRadioButton( qtarch_ButtonGroup, "RadioUpdate" );
   qtarch_RadioUpdate->setFocusPolicy( QWidget::TabFocus );
   qtarch_RadioUpdate->setBackgroundMode( QWidget::PaletteBackground );
   qtarch_RadioUpdate->setText( i18n("Update files") );
   qtarch_RadioUpdate->setAutoRepeat( FALSE );
   qtarch_RadioUpdate->setAutoResize( FALSE );
   qtarch_RadioUpdate->setChecked( FALSE );
   grid2->addWidget(qtarch_RadioUpdate,1,0);

   qtarch_RadioMotif = new QRadioButton( qtarch_ButtonGroup, "RadioMotif" );
   grid2->addWidget(qtarch_RadioMotif,2,0);
   qtarch_RadioMotif->setText( i18n("Use wilcards") );
   qtarch_RadioMotif->setChecked( FALSE );

   qtarch_CheckBox = new QCheckBox( this, "CheckBox" );
   grid1->addMultiCellWidget(qtarch_CheckBox,4,4,1,2);
   qtarch_CheckBox->setFocusPolicy( QWidget::TabFocus );
   qtarch_CheckBox->setBackgroundMode( QWidget::PaletteBackground );
   qtarch_CheckBox->setText( i18n("Delete source files") );
   qtarch_CheckBox->setAutoRepeat( FALSE );
   qtarch_CheckBox->setAutoResize( FALSE );
   qtarch_CheckBox->setChecked( FALSE );

   QPushButton* qtarch_PushOK;
   qtarch_PushOK = new QPushButton( this, "PushOK" );
   grid1->addWidget(qtarch_PushOK,7,1);
   qtarch_PushOK->setFocusPolicy( QWidget::TabFocus );
   qtarch_PushOK->setBackgroundMode( QWidget::PaletteBackground );
   qtarch_PushOK->setText( i18n("OK") );
   qtarch_PushOK->setAutoRepeat( FALSE );
   qtarch_PushOK->setAutoResize( FALSE );
   qtarch_PushOK->setToggleButton( FALSE );
   qtarch_PushOK->setDefault( FALSE );
   qtarch_PushOK->setAutoDefault( FALSE );
   qtarch_PushOK->setIsMenuButton( FALSE );
   connect(qtarch_PushOK,SIGNAL(clicked()),SLOT(OK()));

   QPushButton* qtarch_PushCancel;
   qtarch_PushCancel = new QPushButton( this, "PushCancel" );
   grid1->addWidget(qtarch_PushCancel,7,2);
   qtarch_PushCancel->setText( i18n("Cancel") );
   connect(qtarch_PushCancel,SIGNAL(clicked()),SLOT(Cancel()));

   qtarch_LineFichiers = new QMultiLineEdit( this, "LineFichiers" );
   grid1->addMultiCellWidget( qtarch_LineFichiers ,5,6,1,2);
   
   qtarch_ButtonGroup->insert( qtarch_RadioAjoute );
   qtarch_ButtonGroup->insert( qtarch_RadioUpdate );
   qtarch_ButtonGroup->insert( qtarch_RadioMotif );
   
   resize( 400,305 );
   chemin="";
}


CAjoutFichiers::~CAjoutFichiers()
{
}

void CAjoutFichiers::choisirFichiers()
{
	QFileDialog selectionFichiers(QDir::currentDirPath());
	//selectionFichiers.setMultiSelection(TRUE);
	//QStrList receptionfichiers=selectionFichiers.selectedFileURLList();

	if(selectionFichiers.exec())
	{
		//receptionfichiers=selectionFichiers.selectedFileURLList();
		//for(int i=0;i<receptionfichiers.selectedFileURLList().count();i++)
		//	printf("\n*%s*\n",receptionfichiers.take(i));
  }
}

void CAjoutFichiers::reconstruitChemin(QListViewItem *l)
{
	if(l->depth()!=0)
	{
		chemin="/"+chemin;
		chemin=l->text(0)+chemin;
		reconstruitChemin(l->parent());
	}
	else
	{
		chemin="/"+chemin;
		QString str;
		int i;
		kdDebug()<<QString("*%1*\n").arg(chemin)<<endl;
		i=0;
		for (QString f = listeFichiers.first(); f; f = listeFichiers.next())
		  {
		    str=f;
		    if(str==chemin)
		      {
			listeFichiers.remove(str);
			qtarch_LineFichiers->removeLine(i);
			chemin="";
			return;
		      }
		    i++;
		  }
		listeFichiers.append(chemin);
		qtarch_LineFichiers->insertLine(chemin);
		chemin="";
	}
}

QStrList CAjoutFichiers::getFichiers()
{
	return listeFichiers;
}

void CAjoutFichiers::OK()
{
	done(0);
}

void CAjoutFichiers::Cancel()
{
	done(1);
}

int CAjoutFichiers::getAction()
{
	if(qtarch_RadioAjoute->isChecked())
		return 0;
	else	if(qtarch_RadioUpdate->isChecked())
		return 1;
	return -1;
}

/* Return true if source files should be removed */
bool CAjoutFichiers::getEnleveFichiers()
{
	return qtarch_CheckBox->isChecked();
}

void CAjoutFichiers::selectionneMotif(int i)
{
	if(i==2)
	{
		QStrList listeFichiers2;
		QStringList listeUnicodeFichiers;
		
		listeUnicodeFichiers/*listeFichiers*/=QFileDialog::getOpenFileNames("",QDir::homeDirPath());

		listeFichiers.clear();		
    for ( QStringList::Iterator it = listeUnicodeFichiers.begin(); it != listeUnicodeFichiers.end(); ++it ) {
			listeFichiers.append((*it).latin1());//printf( "%s \n", (*it).latin1() );
		}

		listeFichiers2=listeFichiers;
		qtarch_LineFichiers->clear();

	  for (QString f = listeFichiers.first(); f; f = listeFichiers.next())
   		qtarch_LineFichiers->insertLine(f);
   		
		listeFichiers=listeFichiers2;
	}
}

void CAjoutFichiers::MAJMotif()
{
	if(qtarch_RadioMotif->isChecked())
	{
		QString txt;
//		txt=texte;
		txt+="/";
		listeFichiers.clear();
		listeFichiers.append(txt);
//printf("\n*%s*\n",texte);
	}
}

void CAjoutFichiers::slotSelectionModifiee(QListViewItem* l)
{
	reconstruitChemin(l);
}

#include "cajoutfichiers.moc"
