/***************************************************************************
                          cextraction.cpp  -  description                              
                             -------------------                                         
    begin                : Fri Jun 4 1999                                           
    copyright            : (C) 1999 by Eric Coquelle                         
    email                : coquelle@hivaoa.unice.fr                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "cextraction.h"

#include <qlayout.h>
#include <qgrid.h>
#include <kiconloader.h>

CExtraction::CExtraction(QDialog *parent, const char *name ) : QDialog(parent,name,TRUE) {
	
	KIconLoader icone;
	setIcon(icone.loadIcon("karchiver",KIcon::Small));

  QGridLayout *grid1 = new QGridLayout(this,6,3,15,7);
  QButtonGroup* qtarch_ButtonGroup_1;
  qtarch_ButtonGroup_1 = new QButtonGroup( this, "ButtonGroup_1" );
  qtarch_ButtonGroup_1->setFocusPolicy( QWidget::NoFocus );
  qtarch_ButtonGroup_1->setBackgroundMode( QWidget::PaletteBackground );
  qtarch_ButtonGroup_1->setFrameStyle( 49 );
  qtarch_ButtonGroup_1->setLineWidth( 1 );
  qtarch_ButtonGroup_1->setMidLineWidth( 0 );
  qtarch_ButtonGroup_1->QFrame::setMargin( 0 );
  qtarch_ButtonGroup_1->setTitle( i18n("Extract:") );
  qtarch_ButtonGroup_1->setAlignment( 1 );
  qtarch_ButtonGroup_1->setExclusive( FALSE );
  grid1->addMultiCellWidget(qtarch_ButtonGroup_1,1,4,1,2);

  listView = new QListView( this, "ListView_1" );
  grid1->addMultiCellWidget(listView,0,5,0,0);
  listView->setFocusPolicy( QWidget::TabFocus );
  listView->setBackgroundMode( QWidget::PaletteBackground );
  listView->setFrameStyle( 0 );
  listView->setLineWidth( 1 );
  listView->setMidLineWidth( 0 );
  listView->QFrame::setMargin( 0 );
  listView->setResizePolicy( QScrollView::Manual );
  listView->setVScrollBarMode( QScrollView::Auto );
  listView->setHScrollBarMode( QScrollView::Auto );
  listView->setTreeStepSize( 20 );
  listView->setMultiSelection( FALSE );
  listView->setAllColumnsShowFocus( FALSE );
  listView->setItemMargin( 1 );
  listView->setRootIsDecorated( FALSE );
  listView->addColumn( i18n("Where to extract:"), -1 );
  listView->setColumnWidthMode( 0, QListView::Maximum );
  listView->setColumnAlignment( 0, 1 );

  repertoire=new Directory(listView);
  repertoire->setOpen(TRUE);
  connect(listView, SIGNAL(selectionChanged(QListViewItem*)), this, SLOT(recupere(QListViewItem*)));

  QLabel* qtarch_Label_1;
  qtarch_Label_1 = new QLabel( this, "Label_1" );
  qtarch_Label_1->setFocusPolicy( QWidget::NoFocus );
  qtarch_Label_1->setBackgroundMode( QWidget::PaletteBackground );
  qtarch_Label_1->setFrameStyle( 0 );
  qtarch_Label_1->setLineWidth( 1 );
  qtarch_Label_1->setMidLineWidth( 0 );
  qtarch_Label_1->QFrame::setMargin( 0 );
  qtarch_Label_1->setText( i18n("Extract To:") );
  qtarch_Label_1->setAlignment( 289 );
  qtarch_Label_1->setMargin( -1 );
  grid1->addWidget(qtarch_Label_1,0,1);


  cbExtractDirectory= new KComboBox( true, this, "combo_extract" );
  grid1->addMultiCellWidget(cbExtractDirectory,0,0,2,4);
  cbExtractDirectory->setInsertionPolicy(QComboBox::AtTop);
  cbExtractDirectory->setEditable(true);
  //Basic completion feature
	KCompletion *comp = cbExtractDirectory->completionObject();
	connect(cbExtractDirectory, SIGNAL(returnPressed(const QString&)), comp, SLOT(addItem(const QString&)));


  QGridLayout *grid2 = new QGridLayout( qtarch_ButtonGroup_1,2,1,15,7);
  qtarch_RadioButton_1 = new QRadioButton( qtarch_ButtonGroup_1, "RadioButton_1" );
  qtarch_RadioButton_1->setFocusPolicy( QWidget::TabFocus );
  qtarch_RadioButton_1->setBackgroundMode( QWidget::PaletteBackground );
  qtarch_RadioButton_1->setText( i18n("All files") );
  qtarch_RadioButton_1->setAutoRepeat( FALSE );
  qtarch_RadioButton_1->setAutoResize( FALSE );
  qtarch_RadioButton_1->setChecked( TRUE );
  grid2->addWidget(qtarch_RadioButton_1,0,0);
  
  qtarch_RadioButton_2 = new QRadioButton( qtarch_ButtonGroup_1, "RadioButton_2" );
  qtarch_RadioButton_2->setFocusPolicy( QWidget::TabFocus );
  qtarch_RadioButton_2->setBackgroundMode( QWidget::PaletteBackground );
  qtarch_RadioButton_2->setText( i18n("Selected files") );
  qtarch_RadioButton_2->setAutoRepeat( FALSE );
  qtarch_RadioButton_2->setAutoResize( FALSE );
  qtarch_RadioButton_2->setChecked( FALSE );
  grid2->addWidget(qtarch_RadioButton_2,1,0);
 
  bextraire=new QPushButton(i18n("Extract"), this, "bouton extraction");
  grid1->addWidget(bextraire,5,1);
  bextraire->setFont( QFont( "Times", 18, QFont::Bold ) );
  connect(bextraire, SIGNAL(clicked()), SLOT(FaitExtraction()));	

  QPushButton *bannulle;	
  bannulle=new QPushButton(i18n("Cancel"), this, "bouton annuller");
  grid1->addWidget(bannulle,5,2);
  connect(bannulle, SIGNAL(clicked()), SLOT(PasExtraction()));

  resize( 490,310 );
  
  optionextraction=1;
  chemin="";
  cheminacces=QDir::homeDirPath();
  cbExtractDirectory->setEditText(chemin);
  
  history = new CHistorique();
  
  setHistory();
}

CExtraction::~CExtraction(){
  writeHistory();
}

void CExtraction::FaitExtraction()
{
	chemin=cbExtractDirectory->currentText();
	if(chemin.isEmpty())
		reject();
		
	history->addElement(chemin);
	writeHistory();
	cbExtractDirectory->clear();
	cbExtractDirectory->insertStrList(history->getElements());
	accept();	
}

void CExtraction::recupere(QListViewItem *l)
{
	if(l->depth()!=0)
	{
		chemin="/"+chemin;
		chemin=l->text(0)+chemin;
		recupere(l->parent());
	}
	else
	{
		chemin="/"+chemin;
		cbExtractDirectory->setEditText( chemin );
		chemin="";
	}
}

QString & CExtraction::getCheminAcces()
{
	return chemin;
}

int CExtraction::toutExtraire()
{
	if(qtarch_RadioButton_1->isChecked())
		return 0;
	else
		return 1;
}

void CExtraction::PasExtraction()
{
	reject();	
}

void CExtraction::setCheminAcces(QString Chemin, int optionExtraction){
	optionextraction=optionExtraction;
	cheminacces=Chemin;
	
	switch(optionExtraction)
	{
		case 0:
			cheminacces=Chemin;
			break;
		case 1:
			cheminacces=QDir::homeDirPath();
			break;
		case 2:
			cheminacces=QDir::currentDirPath();
			break;
	}
	cbExtractDirectory->setEditText(cheminacces);			
}

/** Set the default directory */
void CExtraction::setOptionExtraction(int optionExtraction){
	optionextraction=optionExtraction;
}

/** Displays in the text box the default extraction direcrory */
void CExtraction::afficheChemin(){
	chemin="";
	setCheminAcces(cheminacces, optionextraction);
	repaint();
}

/** set the Most Recent Used extract dirs */
void CExtraction::setHistory(){
	QStrList list;
  KConfig *config = kapp->config();

  config->setGroup("LASTDIRS");

	config->readListEntry("LastExtractedDirs",list);
	
	history->setMaxElements(4);
	history->setElements(list);
	
	cbExtractDirectory->clear();
	cbExtractDirectory->insertStrList(history->getElements());
}

/** save the MRU entries */
void CExtraction::writeHistory(){
  KConfig *config = kapp->config();

  config->setGroup("LASTDIRS");

	config->writeEntry("LastExtractedDirs",history->getElements());
}
#include "cextraction.moc"
