/***************************************************************************
                          cextraction.h  -  description                              
                             -------------------                                         
    begin                : Fri Jun 4 1999                                           
    copyright            : (C) 1999 by Eric Coquelle                         
    email                : coquelle@hivaoa.unice.fr                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef CEXTRACTION_H
#define CEXTRACTION_H

#include <qwidget.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qdialog.h>
#include <qpixmap.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qradiobutton.h>
#include <qlistview.h>
#include <qlineedit.h>
#include <qbuttongroup.h>
#include <qlistview.h>
#include <qstring.h>
#include <qfile.h>
#include <qdir.h>

#include <klocale.h>
#include <kapp.h>
#include <kconfig.h>
#include <kcombobox.h>
#include <kcompletion.h>

#include "dirview.h"
#include "chistorique.h"

/**
  *@author Eric Coquelle
  */

class CExtraction : public QDialog  {
   Q_OBJECT
public: 
   CExtraction(QDialog *parent=0, const char *name=0);
   ~CExtraction();
   /** Returns predefined extract path */
   QString & getCheminAcces();
   /** Set predefined extract path */
   void setCheminAcces(QString Chemin, int optionExtraction);
   /** Set the default directory */
   void setOptionExtraction(int optionExtraction);
   /** Displays in the text box the default extraction direcrory */
   void afficheChemin();
   
   public slots:
     /* The path is OK, we can extract*/
     void FaitExtraction();
   /* Close the dialog*/
   void PasExtraction();
   /* Convert the recursive items from class Directory to a valid path*/
   void recupere(QListViewItem*);
   /* Return 0 if all files have to be extracted*/
   int toutExtraire();
   
private:
   QString progrCompresseur;
   QString options;
   QString fichiers;
   /*Used for reconstructing the path give by the dirview*/
   QString chemin;
   
   QListView* listView;
   Directory *repertoire;
   QPushButton *bextraire;
   KComboBox* cbExtractDirectory;
   QRadioButton* qtarch_RadioButton_1;
   QRadioButton* qtarch_RadioButton_2;
   /*Tells which kind of default folder*/
   int optionextraction;
   /*The default path*/

 protected: // Protected methods
   /** save the MRU entries */
   void writeHistory();
   /** set the Most Recent Used extract dirs */
   void setHistory();
   QString cheminacces;
   CHistorique* history;
};

#endif







