/***************************************************************************
                          FILENAME  -  description                              
                             -------------------                                         
    begin                : DATE                                           
    copyright            : (C) YEAR by AUTHOR                         
    email                : EMAIL                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "cinfos.h"

CInfos::CInfos(QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();
	
	//Additionnal init
	KIconLoader icone;
	setIcon(icone.loadIcon("karchiver",KIcon::Small));
	
	leNbFich->setAlignment(Qt::AlignRight);
	leTailleFich->setAlignment(Qt::AlignRight);
	leTailleArchive->setAlignment(Qt::AlignRight);
	leTaux->setAlignment(Qt::AlignRight);
	leMoy->setAlignment(Qt::AlignRight);
	leSigma->setAlignment(Qt::AlignRight);
  QLabel_11->setPixmap(icone.loadIcon("compress",KIcon::Small));
  QLabel_12->setPixmap(icone.loadIcon("extract",KIcon::Small));
  connect(bOk, SIGNAL(clicked()), this, SLOT(slotOk()));
	
	setCaption(i18n("Archive information"));	
}

CInfos::~CInfos(){
}
/** Initialise the line edit widgets so that they display the
requested informations */
void CInfos::initialise(int nbreFichiers, int tailleArchive, int tailleFichiers, int tailleMoyenne, int taux, int sigma)
{
	QString str;
	
	str.setNum(taux);
	leTaux->setText(str);
	str.setNum(tailleMoyenne);
	leMoy->setText(str);
	str.setNum(nbreFichiers);
	leNbFich->setText(str);
	str.setNum(sigma);
	leSigma->setText(str);
	str.setNum(tailleArchive);
	leTailleArchive->setText(str);
	str.setNum(tailleFichiers);
	leTailleFich->setText(str);	

}

/** close the dialog box */

void CInfos::slotOk(){
	accept();
}
#include "cinfos.moc"
