/***************************************************************************
                          FILENAME  -  description                              
                             -------------------                                         
    begin                : DATE                                           
    copyright            : (C) 2000 by Eric Coquelle <coquelle@caramail.com>
    email                : EMAIL                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "cnavigateur.h"

CNavigateur::CNavigateur(QWidget *parent, const char *name) : QDialog(parent,name,false){
	initDialog();
	
	//Additionnal init
	KIconLoader icone;
	
	setIcon(icone.loadIcon("karchiver.png",KIcon::Small));
	
	lChemin->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	
  setCaption(i18n("Archive browser"));
}

CNavigateur::~CNavigateur(){
}

/** Set the current path for the browser */
void CNavigateur::setChemin(const char *chemin)
{
	QStringList listefichiers;
	QDir d;

	lChemin->setText(chemin);
	d.setPath(chemin);

	QListBox_1->clear();
	listefichiers=d.entryList("*gz");
	QListBox_1->insertStringList(listefichiers);
	listefichiers=d.entryList("*bz2");
	QListBox_1->insertStringList(listefichiers);
	listefichiers=d.entryList("*tar");
	QListBox_1->insertStringList(listefichiers);
	listefichiers=d.entryList("*.Z");
	QListBox_1->insertStringList(listefichiers);
	listefichiers=d.entryList("*zip");
	QListBox_1->insertStringList(listefichiers);
	listefichiers=d.entryList("*rar");
	QListBox_1->insertStringList(listefichiers);
	listefichiers=d.entryList("*lha");
	QListBox_1->insertStringList(listefichiers);
	listefichiers=d.entryList("*lzh");
	QListBox_1->insertStringList(listefichiers);
	listefichiers=d.entryList("*arj");
	QListBox_1->insertStringList(listefichiers);
}

/** The user closed the window */
void CNavigateur::closeEvent( QCloseEvent* ){
	emit(windowwillbeclosed());
}
#include "cnavigateur.moc"
