/***************************************************************************
                          cpreferences.h  -  description
                             -------------------
    begin                : Sat Jul 1 2000
    copyright            : (C) 2000 by Eric Coquelle
    email                : coquelle@caramail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CPREFERENCES_H
#define CPREFERENCES_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qpushbutton.h>
#include <qlistbox.h>
//Generated area. DO NOT EDIT!!!(end)

#include <qdialog.h>
#include <qbuttongroup.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qfont.h>
#include <qvbox.h>

#include <kfontdialog.h>
#include <kiconloader.h>
#include <klocale.h>
#include <kapp.h>
#include <kconfig.h>
#include <kstddirs.h>
#include <kdialogbase.h>

/** This class will provide a pretty dialog box in whioch
	* the user can set all the options of karchiveur
  *@author Eric Coquelle
  */

class CPreferences : public KDialogBase  {
   Q_OBJECT
public: 
	CPreferences(QWidget *parent=0, const char *name=0);
	~CPreferences();
  /** return true if we will include the absoute path
		* and not the relative when dropping */
  bool getToutChemin();
  /** returns true if we will use an absolute path
		* for files added to the archive */
  bool getCheminAbsolu();
  /** return the compress rate for gzip ans bzip2
		* 0 = min, 9 = max */
  int getTauxCompression();
  /** return true if we will recurse folders when dropping */
  bool getRecursif();
  /** return true if we will overwrite files while
		* uncompressing gzip and bzip2 archives */
  bool getEcraserGzip();
  /** return 0 if we'll display small icons, 1 for medium,
		* 2 for large */
  int getTailleIconeListe();
  /** return 0 for last dir, 1 for home dir, 2 for shell's one
		* ==>set the default directory when OPENING files */
  int getTypeRepertoireOuverture();
  /** return 0 if we'll open the last dir, 1 for home dir,
		* and 2 for shell's one */
  int getTypeRepertoireExtraction();
  /** return true if we'll read archive using streams,
		* false if we'll read using signal/slot mechanism */
  int getLitParFlot();
  /** return true if files will be overwritten when
	* they are extracted */
  bool getEcraserTar();
  /** return the font for the listview */
  QFont getFont();
  /** set the widgets for the date displayed on the
		* listview */
  void setDateOptions();
  /** return the kind of date that will be displayed in
		* the listview:
		* 0: standard one (compressor's one)
		* 1: localised 1/1/2000
		* 2: localised: Saturday May 2000 */
  int getKindOfDate();
  /** return true if we'll display the tip of the day
		* at startup */
  bool getDisplayTipofDay();
  /** return 0 if we're in standard Multi selection mode
		1 for extended selection mode
		(i.e. ctrl+click to select) */
  int getSelectionMode();

protected: 
	void initDialog();
  /*Read the config file and set the propper values for all widgets*/
	void litOptions();
	/*Save those options*/
	void Sauver();
  /** verify the avaible compressors */
  void compresseursDispo();
  /** set all the widgets for gzip options */
  void setGzipOptions();
  /** set the widgets for the TAR tab */
  void setTarOptions();
  /** set the widgets for default directories */
  void setDirectoriesOptions();
  /** set the widgets for Icon size options tab */
  void setIconSizeOptions();
  /** set the widgets for reading archive options */
  void setArchiveReadingOptions();
  /** set the widgets for avaible compressors */
  /** allow user to select a font for the listview */
  void setFontOptions();
  void setCompresseursOptions();
	/** set the widgets for the TipofDay tab */
	void setTipofDayOptions();
  /** set misc options for karchiveur */
  void setMiscOptions();
	
protected slots: // Protected slots
  /** close the dialog box, and forget the changes */
  void slotAnnuler();
  /** Save the changes */
  void slotSauver();
  /** close the dialog box and use the changes */
  void slotOk();
  /** set all widgets to default settings */
  void slotDefault();


private:
	//Generated area. DO NOT EDIT!!!(begin)
	QGroupBox *gbOptionsGzipBzip2;
	QLabel *QLabel_2;
	QComboBox *cmbOGZTauxCompression;
	QLabel *QLabel_3;
	QLabel *QLabel_4m;
	QCheckBox *cbOGZEcrase;
	QGroupBox *gbOptionsTar;
	QCheckBox *cbOTCheminAbsolu;
	QCheckBox *cbOTToutChemin;
	QCheckBox *cbOTRecursif;
	QCheckBox *cbOTEcrase;
	QGroupBox *gbVisualisateur;
	QGroupBox *gbRepertoires;
	QButtonGroup *gbDDExtraction;
	QRadioButton *rbDDEDDernier;
	QRadioButton *rbDDEDMaison;
	QRadioButton *rbDDEDShell;
	QButtonGroup *gbDDOuverture;
	QRadioButton *rbDDODDernier;
	QRadioButton *rbDDODMaison;
	QRadioButton *rbDDODShell;
	QGroupBox *gbTailleIcones;
	QButtonGroup *gbISFichiers;
	QRadioButton *rbISFPetit;
	QRadioButton *rbISFMoyen;
	QRadioButton *rbISFGrand;
	QPushButton *bOk;
	QPushButton *bSauver;
	QPushButton *bAnnuler;
	QButtonGroup *bgLectureArchive;
	QRadioButton *rbOLVeryFast;
	QRadioButton *rbOLRapide;
	QRadioButton *rbOLLent;
	QGroupBox *gbCompresseursDispo;
	QLabel *lZipDispo;
	QLabel *QLabel_17;
	QLabel *QLabel_5;
	QLabel *lTarDispo;
	QLabel *QLabel_7;
	QLabel *QLabel_8;
	QLabel *QLabel_9;
	QLabel *QLabel_10;
	QLabel *lGzipDispo;
	QLabel *lLhaDispo;
	QLabel *lRarDispo;
	QLabel *lBzip2Dispo;
	QLabel *QLabel_15;
	QLabel *lUnzipDispo;
	QLabel *QLbl_16;
	QLabel *lUnarjDispo;
	QListBox *lbCategorie;
	//Generated area. DO NOT EDIT!!!(end)
	
	/*contains the selected font for the listview*/
	KFontChooser* mFont;
	/* some widgets for the date settings*/
	QButtonGroup *bgDateDisplay;
	QRadioButton *rbDDStandard;
	QRadioButton *rbDDLocalisedSmall;
	QRadioButton *rbDDLocalisedLarge;
	QCheckBox *cbOTDDisplayTipofDay;
	QButtonGroup *gbMOSelectionMode;
	QRadioButton *rbMOSMMulti;
	QRadioButton *rbMOSMExtended;	
	
private:
};

#endif
