/***************************************************************************
                          crar.cpp  -  description
                             -------------------
    begin                : Sat Dec 2 2000
    copyright            : (C) 2000 by Eric Coquelle
    email                : coquelle@caramail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "crar.h"
#include <kdebug.h>
#include <qfile.h>
#include <qdir.h>

CRar::CRar(){
	CArchive();

	connect(&processread,SIGNAL(receivedStdout(KProcess*, char*, int)),this,SLOT(haveSdtOut(KProcess*,char*,int)));
	connect(&processread,SIGNAL(processExited (KProcess*)),this,SLOT(endProcess(KProcess*)));
	connect(&processextract,SIGNAL(receivedStdout(KProcess*, char*, int)),this,SLOT(haveSdtOutExtract(KProcess*,char*,int)));
	connect(&processextract,SIGNAL(processExited (KProcess*)),this,SLOT(endProcess(KProcess*)));

	list->setColumnText(4, i18n("Owner"));
	list->setColumnText(5, i18n("Permissions"));
}

CRar::~CRar(){
}

/** this method will launch the right compressor
to list the file contents
It will then launch the right method to display
the content in the listview */
void CRar::displayArchiveContent(){
	initializeReadingArchive();

	processread <<"rar";
	processread << "vt" << archiveName;

	/*Only without stream works fine...
	if(readArchiveWithStream)
	{
                FILE *flot;
		processread.demarrer(&flot,KProcess::Stdout);
		displayRarArchiveContent(flot);
		displayMessageArchiveSize();
		led->setColor(KLed::green);
	}
	else
	{*/
		m_buffer[0]='\0';
		headerremoved=false;
		finished=false;
		flag=0;
		processread.start(KProcess::NotifyOnExit, KProcess::Stdout);
	//}
}

/** display in a listview the content of the current
rar archive. This method examines the stdout of
unarj to sort useful infos for the listview */
void CRar::displayRarArchiveContent( FILE* flot ){
	CListViewItem* elementListe;
	char tampon[5000];
	char permission[30];
	QString proprietaire;
	char crc[20];
	char taille[30];
	char date[12];
	char heure[7];
	char snom[5000];
	char methode[20];
	QString chemin;
	QString nom;
	QString message;
	int i;


	do
		fgets( tampon, 5000, flot );
	while( !feof(flot) && (strstr( tampon, "-------------------------------------------------------------------------------" )==NULL));
	fgets( tampon, 5000, flot );
	while( !feof(flot) && (strstr( tampon, "-------------------------------------------------------------------------------" )==NULL))
	{
		sscanf(tampon, " %[a-zA-Z0-9:._-] %[0-9] %[0-9] %[0-9%] %[0-9-] %[0-9:] %[a-zA-Z0-9-] %[a-zA-Z0-9] %[a-zA-Z0-9] %[^\n]",snom, taille, crc, permission, date, heure, crc, crc, crc, methode );

		nom=snom;
		nom=" "+nom;
		i=nom.findRev('/');
		if(i!=-1)
		{
			chemin=nom.left(i+1);
		 	nom=nom.remove(0,i+1);
		if(nom=="")nom="..";
		}
		else
			chemin="";
		elementListe=new CListViewItem(list,nom,taille,heure,date,proprietaire,permission,chemin);
		definitIcone(nom, permission, elementListe);
		elementListe->widthChanged();
		fgets( tampon, 5000, flot );
	}
	fclose( flot );
}

/*Overloaded method*/
void CRar::displayRarArchiveContent( const char* line){
	CListViewItem* elementListe;
/*	char permission[30];
	char crc[20];
	char size[30];
	char packed[30];
	char ratio[10];
	char version[10];
	char day[10];
	char heure[7];
	char sname[5000];
	char method[20];
	QString chemin;
	QString nom;
	int i;*/

	char columns [11][80];
	char sname [5000];
	QString name, path;
	int i;

  ++flag;
  if ( flag== 1)
    {
      m_line1 = line;
      return;
    }
  if (flag == 2)
    {
      m_line2 = line;
      return;
    }
  // if we made it here, we have all three lines.
  // Reset the line number.
  flag = 0;

  sscanf(QFile::encodeName(m_line1), " %[^\n]", sname);
  sscanf((const char *)m_line2.ascii(), " %[0-9] %[0-9] %[0-9%] %2[0-9]-%2[0-9]-%2[0-9] %5[0-9:] %[A-Za-z.-] %[A-F0-9] %[A-Za-z0-9] %[0-9.]",
	 columns[0], columns[1], columns[2], columns[3],
	 columns[8], columns[9], columns[10],
	 columns[4], columns[5], columns[6],
	 columns[7]);

	//sscanf(ligne, " %[a-zA-Z0-9:._-] %[0-9] %[0-9] %[0-9%] %[0-9-] %[0-9:] %[a-zA-Z0-9] %[a-zA-Z0-9] %[a-zA-Z0-9] %[^\n]",sname, size, packed, ratio, day, heure, permission, crc, method, version );

  QString timestamp;
  timestamp.sprintf("%s-%s-%s", columns[9],
		    columns[8], columns[3]);


		name=sname;
		name=" "+name;
		i=name.findRev('/');
		if(i!=-1)
		{
			path=name.left(i+1);
		 	name=name.remove(0,i+1);
			if(name=="")name="..";
		}
		else
			path="";

		elementListe=new CListViewItem(list,name,columns[0],columns[10],timestamp.ascii(),columns[2],columns[4],path);
		definitIcone(name, columns[4], elementListe);
		elementListe->widthChanged();
}

/** we recive some informations through the standard
output of the process */
void CRar::haveSdtOut(KProcess *, char *buffer, int length){
	//Has user canceled current action ?
	if(stopreadprocess)
		return;

	// This section is here only for testing. It has been taken from ark:
	//1997-1999: Rob Palmbos palm9744@kettering.edu
	//2000: Corel Corporation (author: Emily Ezust, emilye@corel.com)
	//and adapted to karchiveur
  char c = buffer[length];
  buffer[length] = '\0';

//  m_settings->appendShellOutputData( buffer );

  char line[1024] = "";
  char *tmpl = line;
  char *tmpb;

  displayMessage(i18n("Running compressor..."));


  //We copy m_buffer to tmpl
  for( tmpb = m_buffer; *tmpb != '\0'; tmpl++, tmpb++ )
    *tmpl = *tmpb;

  //We copy the fisrt string of buffer (till \n) to tmpl
  for( tmpb = buffer; *tmpb != '\n'; tmpl++, tmpb++ )
    *tmpl = *tmpb;

  tmpb++;
  *tmpl = '\0';

  if( *tmpb == '\0' )
    m_buffer[0]='\0';

  if( !strstr( line, "----" ) )
  {
		if( headerremoved && !finished )
	  	displayRarArchiveContent( line );
	}
  else if(!headerremoved)
    headerremoved = true;
  else
    finished = true;


  bool stop = (*tmpb == '\0');

  while( !stop && !finished)
  {
      tmpl = line; *tmpl = '\0';

      for(; (*tmpb!='\n') && (*tmpb!='\0'); tmpl++, tmpb++)
				*tmpl = *tmpb;

      if( *tmpb == '\n' )
			{
			  *tmpl = '\n';
			  tmpl++;
			  *tmpl = '\0';
			  tmpb++;

			if( !strstr( line, "----" ) )
	  	{
	    	if( headerremoved )
	    	{
	  			displayRarArchiveContent( line );
	  		}
	  	}
			else if( !headerremoved )
	  		headerremoved = true;
			else
		    finished = true;


			}
      else if (*tmpb == '\0' )
			{
	  		*tmpl = '\0';
			  strcpy( m_buffer, line );
	  		stop = true;
			}
    }
  buffer[length] = c;
}

/** we recive some informations through the standard
	* output of the process */
void CRar::haveSdtOutExtract(KProcess *, char *buffer, int length){
	QString inter;
	int i=0;

	inter=buffer;
	inter=inter.left(length);

	while((i=inter.find('\n',i+1))!=-1){
		progressbar->advance(1);
	}
}

/** The current process ended */
void CRar::endProcess(KProcess*){
  kdDebug()<<("Process ENDED\n");
	led->setColor(QColor("green"));
	displayMessageArchiveSize();
	progressbar->setValue(0);

	emit(archiveReadEnded());
}

/** Upon the kind of archive, choose the right
	*uncompressor and extract all or some files
	*@toutextraire = 9: extract to karchiveur's temp directory (for viewing)
	*@toutextraire = 1: extract all selected files
	*/
void CRar::extractArchive(QString & extractpath, int extractall, QString &filetoextract){
 	int k,l;
 	QString optionRepertoire;
 	QString nomextrait;
 	QString fichiersaextraire;
 	QListViewItem *vi;

//printf("\nEntering Dcompression:%d\n",toutextraire);
 	optionRepertoire="";
 	fichiersaextraire="";
 	counter=0;
 	progressbar->setValue(0);
  progressbar->setRange(0,list->childCount());

 	processextract.clearArguments();
 	processextract << "unrar";
	processextract << "x";
	processextract << "-y";
	if(!overwrite)
		processextract << "-o+";
//printf("\nExtrArch*%s*%s*%s*%s*%s*\n",(const char*)programme,fichier->getOptionSupp(),fichier->getDecompresseur(),fichier->getNomFichier(),(const char*)optionRepertoire);

 	processextract << archiveName;

 	//We will extract all selected files
 	if(extractall==1)
 	{
 		l=0;
 		vi=list->firstChild();
 		for(k=0;k<list->childCount();k++)
 		{
 			if((vi->isSelected())&&(strcmp(vi->text(0),"..")!=0))
 			{
 				fichiersaextraire+=vi->text(6);
 				fichiersaextraire+=vi->text(0);
 				fichiersaextraire=fichiersaextraire.right(fichiersaextraire.length()-1);
 				processextract << fichiersaextraire;
 				fichiersaextraire="";
 				l++;
 			}
 			vi=vi->nextSibling();
 		}
 		progressbar->setRange(0,l);
 	}
 	//We want to view (and so extract) only one file. So we just add this file to the tar or unzip
 	//command. For gzip and bzip2 files, in any case, we extract one and only one file, so I put
 	//it apart
 	else if(extractall==9)
 	{
 		processextract << filetoextract;
	 	processextract << extractpath;
 		if(processextract.start(KProcess::Block)==FALSE)
		  kdDebug()<<("\n*PB PROCESS*\n");
 	}

 	//We extract through the Stdout to have a progress indicator
 	if(extractall!=9)
 	{
	 	processextract << extractpath;
 		if(processextract.start(KProcess::NotifyOnExit,KProcess::Stdout)==FALSE)
		  kdDebug()<<("\n*PB PROCESS*\n");
 	}
 	counter=0;
}

/** delete @param filestodelete from current archive */
void CRar::removeFilesFromArchive (QStrList filestodelete){
  kdDebug()<<("In:enleveFichiersArchiveRAR\n");
 	processread.clearArguments();
 	processread << "rar" << "d";
 	processread << archiveName;
  for (QString f = filestodelete.first(); f; f = filestodelete.next())
  {
    kdDebug()<<QString("Will remove:%1*").arg(f)<<endl;
    processread << f;
  }
  processread.start(KProcess::Block);
  kdDebug()<<("Ok:enleveFichiersArchiveRAR\n");
}

/** Add some files to the archive
@param filestoadd : list of files to add
@param removeoriginalfiles : remove or not those files from disk
@param action : 0=mode append and replace files, 1=mode update files
@param relativepath : if !NULL, include only filenames, without their base path */
void CRar::addFilesToArchive( QStrList filestoadd, bool removeoriginalfiles, int action, const char* relativepath){
	QString s;

	if(relativepath!=NULL)
		QDir::setCurrent(relativepath);

	processread.clearArguments();
	processread << "rar";
	processread << "a";
	
	switch(action)
	{
		case 1:
			//Mode update
			processread << "-u";
			break;
	}
	
	if(removeoriginalfiles)
		processread << "-df";
	
	if(recursivemode)
		processread << "-r";

	processread << archiveName;
	for (QString f = filestoadd.first(); f; f = filestoadd.next())
	{
	  s=f;
	  if(s.right(1)=="/")
	    s.truncate(s.length()-1);
	  if(s.find("file:")==0)
	    s.remove(0,5);
	  kdDebug()<<QString("AjArchRar:%1*in:%2*").arg(s).arg(archiveName)<<endl;
  	processread << s;
	}
	processread.start(KProcess::Block);
}

/** Create a rar archive
@param  nameofarchive: the name of the zip archive
@param param: list of files to add
@param relativepath: include only filenames, without their path */
void CRar::createArchive(QString nameofarchive, QStrList filestoadd, const char* relativepath) {
	QString str;

	archiveName=nameofarchive;
	kdDebug()<<QString("DebutCreationRar*%1*%2*").arg(nameofarchive).arg(relativepath)<<endl;
	addFilesToArchive(filestoadd, false, 0,relativepath);
	kdDebug()<<("\nEndCreateRar\n");
}

#include "crar.moc"
