/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : mer jun 14 00:26:31 CEST 2000
    copyright            : (C) 2000-2001 by Eric Coquelle
    email                : coquelle@caramail.com
 ***************************************************************************/

/***************************************************************************
**
** Projet kArchiveur
** Par Eric Coquelle
** Licence d'utilistaion: GPL
**
**
**	Le projet kArchiveur vise  donner  Linux et KDE un gestionnaire de
**	fichiers compresss digne de ce nom,  la fois puissant et intuitif.
**
**   Ce programme est un logiciel libre; vous pouvez le redistribuer et/ou
**   le modifier selons les conditions de la Licence GNU publie par la
**   Free Software Foundation; soit la version 2 de la Licence, ou (selon
**   votre prfrence) toute version ultrieure.
**
**   Ce logiciel est distibu avec l'espoir qu'il sera utile, mais SANS
**   AUCUNE GARANTIE; Reportez vous  la Licence GNU pour plus de dtails.
**
**
 ***************************************************************************/

/***************************************************************************
**
** Project kArchiveur
** By Eric Coquelle
** Under licence : GPL
**
**
**	The goal of the kArchiveur project is to provide Linux and KDE a real
**	compressed files manager, both powerful and intuitive.
**
**
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qdir.h>

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>
#include <kdebug.h>
#include "karchiveur.h"


static const char *description =
	I18N_NOOP("KArchiver for KDE2\nAn easy tool to manage all your compressed files!\nReleased under GNU license");
	
	
static KCmdLineOptions options[] =
{
  { "+[File]", I18N_NOOP("file to open"), 0 },
  { "x", 0, 0 },
  { "extract <directory>", I18N_NOOP("Extract to the specified directory"), 0},
  { "xe", 0, 0 },
  { "extractgui", I18N_NOOP("Extract and choose directory in a dialog box"), 0},
  { "xh", 0, 0 },
  { "extracthere", I18N_NOOP("Extract to current directory"), 0},
  { "xa", 0, 0 },
  { "extractarchdir", I18N_NOOP("Extract to the directory where the archive is"), 0},
  { "c", 0, 0 },
  { "compress", I18N_NOOP("Make a .tar.gz archive from those files"), 0},
  { 0, 0, 0 }
};

int main(int argc, char *argv[])
{

	KAboutData aboutData( "karchiver", I18N_NOOP("KArchiver"),
		VERSION, description, KAboutData::License_GPL,
		"(c) 2001, Eric Coquelle","","http://perso.wanadoo.fr/coquelle/karchiver/");
	aboutData.addAuthor("Eric Coquelle",I18N_NOOP("Developer and Maintainer"), "coquelle@caramail.com","http://perso.wanadoo.fr/coquelle/karchiver/");
	aboutData.addCredit("JP Martin", I18N_NOOP("Bug track and icon designer"), "jeanphilippemartin@club-internet.fr" );
	aboutData.addCredit("L. Montel", I18N_NOOP("Code improvement"), "lmontel@mandrakesoft.com" );
	KCmdLineArgs::init( argc, argv, &aboutData );
	KCmdLineArgs::addCmdLineOptions( options );

  KApplication app;
 
  if (app.isRestored())
  {
    RESTORE(KarchiveurApp);
  }
  else 
  {
    KarchiveurApp *karchiveur = new KarchiveurApp();
    karchiveur->show();

    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
		
		if (args->count())
		{
			QStrList strl;
			QCString archivedir;
			
			KURL url;
			
   		 QCString extractiondirectory = args->getOption("extract");
   		 bool extract_in_gui = args->isSet("extractgui");
   		 bool  extract_this_dir= args->isSet("extracthere");
   		 bool  extract_archive_dir= args->isSet("extractarchdir");
   		 bool compress_files=args->isSet("compress");
   		 QStrList filestocompress;
   		 int i;

			for(i=0; i<args->count(); i++)
			{
				url=args->url(i);
				strl.append(url.url());
			}
			if(!extractiondirectory.isNull())
				karchiveur->extractFromCommandLine( strl, false, extractiondirectory);
			else if(extract_in_gui)
				karchiveur->extractFromCommandLine( strl, true, "");
			else if(extract_this_dir)
				karchiveur->extractFromCommandLine( strl, false, QCString(QDir::currentDirPath()));
			else if(extract_archive_dir)
				karchiveur->extractFromCommandLine( strl, false, "", true);
			else if(compress_files)
			{
				/*for(i=0; i<compress_files.count(); i++)
				{
					//extractiondirectory=compress_files.at(i);
					filestocompress.append(QString(compress_files.at(i)));
				}*/
				kdDebug()<<QString("Will compress: %1\n").arg(strl.first());
				karchiveur->createArchiveFromCommandLine( strl );
			}
			else
				karchiveur->openFileFromCommandLine(strl);
		}
		else
		{
		  //karchiveur->openDocumentFile();
		}
		args->clear();
  }

  return app.exec();
}  
